import type { AxiosInstance, AxiosRequestConfig, AxiosResponse } from 'axios';
import { EventEmitter } from '../min-utils';
import { ApiRequestConfig, ApiRule, ResponseData } from './api_types';
import { ApiChannel } from './api_types';
import type { TokenHandler } from './token/token';
export interface ApiConfigOptions {
    tokenHandler: TokenHandler;
    onServerError?: <T = any>(data: ResponseData<any>, config: ApiRequestConfig<T>) => Promise<{
        capture: boolean;
    }>;
}
export interface onResponseData {
    response: AxiosResponse;
    config: ApiRequestConfig<any>;
    error: Error | null;
    data: any;
}
export declare enum ApiEvent {
    onRequest = 0,
    onResponse = 1,
    onInit = 2
}
export declare function apiCatch<T>(p: Promise<ResponseData<T>>): Promise<ResponseData<T>>;
export declare function initApiConfig(c: ApiConfigOptions): void;
export declare function fetcher<T>(config: ApiRequestConfig<T>, input: any): Promise<AxiosResponse<any, any>>;
export interface ApiParams<T = any, V = any> {
    rule: ApiRule<T>;
    axios: AxiosInstance;
    channel: ApiChannel;
    input: any;
    config: AxiosRequestConfig<V>;
}
export interface ApiRequestEvent {
    axios: AxiosInstance;
    config: AxiosRequestConfig<any>;
    input: any;
    channel: ApiChannel;
    rule: ApiRule;
}
export declare function getTokenHandler(): TokenHandler;
export declare function getApiEmitter(): EventEmitter<ApiEvent, (data: any) => any>;
export declare function getAuthInstance(): AxiosInstance;
export declare function getPublicInstance(): AxiosInstance;
