import { SyncEmitter2, SyncEmitter3, SyncEmitter4 } from "../event";
import { Config, ConfigEvents } from "./types";
export interface CConfigEvents extends ConfigEvents {
    emitInited: SyncEmitter2<Config, any>;
    emitDataChanged: SyncEmitter4<Config, string, any, any>;
    emitConfigAdded: SyncEmitter3<Config, string, Config>;
    emitConfigRemoved: SyncEmitter3<Config, string, Config>;
}
export declare class CConfig implements Config {
    protected events: CConfigEvents;
    protected data: any;
    protected children: Map<string, Config>;
    constructor(events: CConfigEvents, data?: any);
    removeValue(...keys: string[]): void;
    getValue<V = any, T = string>(key: T): V;
    setValue<V = any, T = string>(key: T, value: V): boolean | void;
    setMultiValue<T extends string | number | symbol = string>(values: Record<T, any>): void;
    asData<T>(): T;
    private normalNode;
    setChild(key: string, value: Config | Record<string | number | symbol, any>): void;
    getChild(key: string): Config;
    removeChild(key: string): Config;
    getChildKeys(): string[];
    hasChild(key: string): boolean;
    getJs(ignoreFilter?: ((target: Record<string | number | symbol, any>, key: string) => boolean) | undefined): any;
}
