import { SyncSubscriber2, SyncSubscriber3, SyncSubscriber4 } from "../event";
export interface Config {
    getValue<V = any, T = string>(key: T): V;
    setValue<V = any, T = string>(key: T, value: V): boolean | void;
    setMultiValue<T extends string | number | symbol = string>(values: Record<T, any>): void;
    removeValue(...keys: string[]): void;
    asData<T>(): T;
    setChild(key: string, value: Config | Record<string | number | symbol, any>): void;
    getChild(key: string): Config;
    hasChild(key: string): boolean;
    getChildKeys(): string[];
    removeChild(key: string): Config;
    getJs(ignoreFilter?: (target: Record<string | number | symbol, any>, key: string) => boolean): any;
}
export interface ConfigEvents {
    onConfigInited: SyncSubscriber2<Config, any>;
    onConfigChanged: SyncSubscriber4<Config, string, any, any>;
    onConfigAdded: SyncSubscriber3<Config, string, Config>;
    onConfigRemoved: SyncSubscriber3<Config, string, Config>;
}
export interface ConfigManager extends Config, ConfigEvents {
}
