export declare class EventEmitter<T = string, V = Function> {
    private events;
    constructor();
    on(event: T, callback: V): void;
    before(event: T, callback: V): void;
    off(event: T, callback: V): void;
    once(event: T, func: V): void;
    subscribe(eventName: T, func: V): () => void;
    emit(event: T, ...args: any): void;
    pipe(event: T, args: any, onerror?: any): Promise<any>;
    exec(event: T, args: any, onerror?: any): Promise<any>;
}
