export type SyncSubscriber<T> = (h: (t: T) => void) => () => void;
export type SyncSubscriber2<T, V> = (h: (t: T, v: V) => void) => () => void;
export type SyncSubscriber3<T, V, B> = (h: (t: T, v: V, b: B) => void) => () => void;
export type SyncSubscriber4<T, V, B, M> = (h: (t: T, v: V, b: B, m: M) => void) => () => void;
export type AsyncSubscriber<T> = (h: (t: T) => Promise<void>) => () => void;
export type AsyncSubscriber2<T, V> = (h: (t: T, v: V) => Promise<void>) => () => void;
export type AsyncSubscriber3<T, V, B> = (h: (t: T, v: V, b: B) => Promise<void>) => () => void;
export type AsyncSubscriber4<T, V, B, M> = (h: (t: T, v: V, b: B, m: M) => Promise<void>) => () => void;
export type SyncEmitter<T> = (t: T) => void;
export type SyncEmitter2<T, V> = (t: T, v: V) => void;
export type SyncEmitter3<T, V, B> = (t: T, v: V, b: B) => void;
export type SyncEmitter4<T, V, B, M> = (t: T, v: V, b: B, m: M) => void;
export type AsyncEmitter<T> = (t: T) => Promise<void>;
export type AsyncEmitter2<T, V> = (t: T, v: V) => Promise<void>;
export type AsyncEmitter3<T, V, B> = (t: T, v: V, b: B) => Promise<void>;
export type AsyncEmitter4<T, V, B, M> = (t: T, v: V, b: B, m: M) => Promise<void>;
export interface EventNsHandler<T = any> {
    subscriber: <V>(event: T) => V;
    emitter<V>(event: T): V;
}
export interface EventSimpleHandler<I, O> {
    subscriber: () => I;
    emitter(): O;
}
export interface EventHandler<T = any> {
    createSubscriber: <V>(event: T, ns?: string) => (v: V) => void;
    createEmitter<V>(event: T, ns?: string): V;
    getNamespace: <T>(ns: string) => EventNsHandler<T>;
    random: <I, O>() => EventSimpleHandler<I, O>;
}
export declare function createEventHandler<T = any>(): EventHandler<T>;
